#include "WProgram.h"
void glide();
void freqout(int freq, int t);
#include "math.h"
/* -------Arduino Proto-Synth 08/07/07
  --------Collin Cunningham - Narbotic.net
  --------with portions of code from "Freqout" by Paul Badger and "MIDI drum kit" by Tod E. Kurt

  This is my stab at a monophonic synthesizer for the Arduino and my first stab at coding anything really. 
  It reads input on Analog0 for a stepped pitch transposition. Each note switch(digipins 1-10 & 13) connects to 
  ground in order to register. Higher notes get priority.  Pin 11 is speaker output.  
  I used a little RC Low Pass Filter to smooth out the sound:
  
  PIN11->------\/\/\---o----\/\/\----o-------> OUTPUT
               1K      |    1K       |
                       |             |
                   .1uF_cap      .1uF_cap
                       |             |
                      GND           GND
                      
            (no clue how to draw caps in ascii)
                      
  Features I'd like to add 
  - Another octave (maybe add a transpose switch on each of the next octave, then they can share pins with the first)
  - Last note hit priority
  - Portamento (note-slide)
  - Real sine wave out (no external LPF anymore please) 
  - Polyphony (I had it working badly, need better math)
  - any real keyboard feature in existance(or not) attack, decay, waveform, vibrato, etc.
  
Contact me at narbotic.net with any suggestions/help - and if you improve any of the code please send it on over.

*/

//#define switchAPin 0
//#define switchBPin 1
//#define switchCPin 2
//#define switchDPin 3
//#define switchEPin 4
//#define switchFPin 5
//#define switchGPin 6
//#define switchHPin 7
//#define switchIPin 8
//#define switchJPin 9
//#define switchKPin 10
//#define switchLPin 12
//#define switchMPin 13

//#define pitchPin     0
#define speakerOut  11

int pitchval = 1;
int val = 0;
int j;
int k;
int l;
int freq,t;
int randomend;
int phase = 50;

int inputPin = 2;   // choose the input pin (for a pushbutton)

int frequency = 900;

int frandstart = 1;
int frandstop = 10;

float noteval;

void setup() {
  Serial.begin(9600);
  pinMode(inputPin, INPUT);    // declare pushbutton as input
  pinMode(speakerOut, OUTPUT);

}

// Pins are read in reverse to give higher key priority

void loop() {
  pitchval = 1;
 
  //val = digitalRead(inPin);  // read input value

  val = digitalRead(inputPin);  // read input value
  if (val == HIGH) {            // check if the input is HIGH
    phase = random(10,100);
    digitalWrite(13, LOW);  // turn LED OFF
    
  } else {
    digitalWrite(13, HIGH); // turn LED ON
    Serial.println("Glide");
    glide(); 
  }
  /*if (val == LOW) { 
     
    Serial.println("stop");
    }
  */  
  //frequency = analogRead(pitchPin) / 25;
  //randomend = analogRead(pitchPin);
  for (j=1;j<10;j++){
  //freqout(frequency/j, t);
  }
}

void glide() {
  for (k=0; k<phase; k++){
    // k good between 100 and 200
    frequency = k *random(frandstart,frandstop);
    //delay(100);
    freqout(frequency, t);
    }
  for (l=0; l<phase; l++){
    randomend = (phase-l)*random(frandstart,frandstop);
    //delay(100);
    freqout(randomend, t);
    }
}
//freqout code by Paul Badger (and hacked a bit by me)
void freqout(int freq, int t) 
{ 
    int hperiod;     //calculate 1/2 period in us 
    long cycles, i; 
          t = random(1,freq);
    // hperiod = (500000 / ((freq - 7) * random(1,randomend)));
    hperiod = 500/freq;
    //hperiod = random (5000, hperiod); 
    //Serial.println(hperiod);    // subtract 7 us to make up for digitalWrite overhead - determined empirically 
    // calculate cycles 
    cycles = ((long)freq * (long)t) / 30;    // calculate cycles 

    for (i=0; i<= cycles; i++){              // play note for t ms  
       digitalWrite(speakerOut, HIGH);  
       delayMicroseconds(hperiod); 
       digitalWrite(speakerOut, LOW);  
       delayMicroseconds(hperiod - 1);     // - 1 to make up for fractional microsecond in digitaWrite overhead 
    } 
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

